<template>
	<v-form v-model="valid">
		<v-container grid-list-md>
			<v-layout wrap>
				<v-flex xs12>
					<v-text-field
						label="Description"
						prepend-icon="fa-sticky-note"
						v-model="value.description"
						:rules="descriptionRules"
						required
						@input="update"
					/>
				</v-flex>
				<v-flex xs12>
					<v-checkbox
						label="Done"
						prepend-icon="fa-check"
						v-model="value.done"
						required
						:rules="doneRules"
						@input="update"
					/>
				</v-flex>
				<v-flex xs12>
					<v-slider
						label="Priority"
						:tick-labels="priorities"
						:color="colors[priority]"
						always-dirty
						min="0"
						max="2"
						v-model="priority"
						:rules="priorityRules"
						@input="update"
					/>
				</v-flex>
				<v-flex xs12>
					<v-menu
						v-model="calendar"
						:close-on-content-click="false"
						:nudge-right="40"
						transition="scale-transition"
						offset-y
						full-width
						min-width="290px"
					>
						<template #activator="{ on }">
							<v-text-field
								label="Date created"
								prepend-icon="fa-calendar-check"
								v-model="date"
								readonly
								v-on="on"
								:rules="dateRules"
								@input="update"
							/>
						</template>
						<v-date-picker v-model="date" no-title scrollable @input="update" />
					</v-menu>
				</v-flex>
			</v-layout>
		</v-container>
	</v-form>
</template>

<script>
import { Task, getPriority, priorities, colors } from "@/models/Task";
import formValidity from "@/mixins/FormValidity";
import taskBasicValidation from "@/mixins/TaskBasicValidation";

const defaults = {
	priority: 1,
	date: new Date().toISOString().substr(0, 10),
	calendar: false
};

export default {
	mixins: [formValidity, taskBasicValidation],

	props: {
		value: {
			type: Task,
			required: true
		}
	},

	data() {
		return {
			priority: defaults.priority,
			date: defaults.date,
			calendar: defaults.calendar,
			priorityRules: [],
			dateRules: [
				v => !!v || "Creation date is required"
			]
		};
	},

	computed: {
		priorities() {
			const arr = [];
			for (let prop in priorities) {
				arr.push(priorities[prop]);
			}
			return arr;
		},

		colors() {
			const arr = [];
			for (let prop in colors) {
				arr.push(colors[prop]);
			}
			return arr;
		}
	},

	methods: {
		update() {
			this.value.priority = getPriority(this.priority);
			this.value.creationDate = this.date;
			this.$emit("input", this.value);
		}
	}
};
</script>
